package com.chinaitop.depot.agent.bgz.service;

import java.util.List;
import java.util.Map;

import com.chinaitop.depot.agent.basic.model.BusinessAgentDepot;
import com.chinaitop.depot.agent.bgz.model.BusinessAgentBgmxz;
import com.chinaitop.depot.agent.bgz.model.BusinessAgentBgmxzExample;

public interface BusinessAgentBgmxzService {

	/**
	 * 查询保管明细账列表数据
	 * 
	 * @param param_map 条件
	 * @return
	 */
	List<BusinessAgentBgmxz> findByConditions(Map<String, Object> param_map);

	/**
	 * 按ID查询一条保管明细账数据
	 * 
	 * @param id 数据ID
	 * @return
	 */
	BusinessAgentBgmxz findByParmaryKey(Integer id);

	/**
	 * 新增保管明细账
	 * 
	 * @param bgmxz 数据对象
	 */
	void insert(BusinessAgentBgmxz bgmxz);

	/**
	 * 修改保管明细账
	 * 
	 * @param bgmxz 数据对象
	 */
	void update(BusinessAgentBgmxz bgmxz);

	/**
	 * 删除一条保管明细账数据
	 * 
	 * @param id 数据ID
	 */
	void remove(Integer id);

	/**
	 * 查询分仓保管账列表 
	 * 
	 * @param map 条件
	 * @return
	 */
	List<Map<String, Object>> selectFcbgzList(Map<String, Object> map);

	/**
     * 查询代储库正常使用的货位数据信息
     * 
     * @param paramMap 条件
     * @return
     */
    List<Map<String, Object>> selectAgentHouseWareList(Map<String, Object> paramMap);

    /**
     * 按条件查询代储库数据
     * 
     * @param orgId 当前单位ID
     * @param dckId 代储库ID
     * @return
     */
    BusinessAgentDepot selectAgentDepotObj(Integer orgId, Integer dckId);

    /**
     * 修改代储货位表的最后修改时间
     * 
     * @param orgId 单位ID
     */
	void updateAgentDepot(Integer orgId);
}
