package com.chinaitop.depot.agent.quality.service;

import com.chinaitop.depot.agent.quality.model.BusinessAgentQuality;
import com.chinaitop.depot.agent.quality.model.BusinessAgentQualityExample;
import com.chinaitop.depot.agent.quality.model.BusinessAgentQualitySon;

import java.util.List;
import java.util.Map;

public interface AgentQualityService {

	/**
	 * 按条件查询qualitycheck列表
	 *
	 * @param example
	 * @return
	 */
	List<BusinessAgentQuality> findByCondition(BusinessAgentQualityExample example);

	/**
	 * 条件查询qualitycheck列表
	 *
	 * @param example
	 * @return
	 */
	List<BusinessAgentQuality> queryByQualitycheck(BusinessAgentQuality example);

	/**
	 * 新增qualitycheck信息
	 *
	 * @param qualitycheck
	 */
	Integer save(BusinessAgentQuality qualitycheck);

	/**
	 * 新增qualitycheck字表信息
	 *
	 * @param qualitycheckone
	 */
	void saveOne(BusinessAgentQualitySon qualitycheckone);

	/**
	 * 根据id查询数据
	 *
	 * @param id
	 * @return
	 */
	BusinessAgentQuality loadDataById(Integer id);

	/**
	 * 根据主键id删除数据
	 *
	 * @param id
	 */
	void remove(int id);

    /**
     * @param qualitycheck
     * @return
     */
    List<BusinessAgentQuality> getHouseOrWareList(
            BusinessAgentQuality qualitycheck);

    /**
     * @param id
     * @return
     */
    String getQualityStandardStr(Integer id);

	/**
	 * 查询第三方检查列表
	 * @param qualitycheck
	 * @return
	 */
	List<BusinessAgentQuality> getThirdCheckList(BusinessAgentQuality qualitycheck);
	/**
	 * 查询粮情专卡中粮食质量检测记录
	 * @param qualitycheck
	 * @return
	 */
	List<BusinessAgentQuality> getQualitycheckListByFoodbasicinfoCheck(BusinessAgentQuality qualitycheck);

	void setQualityCheckByHistoryStatus (Integer houseId, Integer warehouseId);
	List<Map<String,Object>> getStoreQualityList();
	List<BusinessAgentQuality> getTrdStoreQualityList();

	List<BusinessAgentQuality> getDataByZJId(Map<String, Object> paramMap);


	/**
	 * 取出封仓需要的数据
	 * @param qualityCheckExample
	 * @return
	 */
	List<BusinessAgentQuality> queryByQualitycheckData(BusinessAgentQuality qualityCheckExample);

	/**
	 * 查看business_store_ware_detail中是否有数据
	 * @param qualityCheckExample
	 * @return
	 */
	List<BusinessAgentQuality> queryByQualitycheckusiness(BusinessAgentQuality qualityCheckExample);

	/**
	 * 导入
	 *
	 * @param list
	 * @param orgId
	 * @return
	 */
	String importData(List<List<String>> list, Integer orgId, Map<String, Object> agentMap, String checktype);

	/**
	 * 春秋导入
	 *
	 * @param list
	 * @param orgId
	 * @return
	 */
	String importDataCQ(List<List<String>> list, Integer orgId, Map<String, Object> agentMap, String checktype);
}
