package com.chinaitop.depot.agent.quality.service.impl;

import com.chinaitop.depot.agent.basic.mapper.BusinessAgentMapper;
import com.chinaitop.depot.agent.quality.mapper.BusinessAgentQualityMapper;
import com.chinaitop.depot.agent.quality.mapper.BusinessAgentQualitySonMapper;
import com.chinaitop.depot.agent.quality.model.BusinessAgentQuality;
import com.chinaitop.depot.agent.quality.model.BusinessAgentQualityExample;
import com.chinaitop.depot.agent.quality.model.BusinessAgentQualitySon;
import com.chinaitop.depot.agent.quality.service.AgentQualityService;
import com.chinaitop.utils.ParameterUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class AgentQualityServiceImpl implements AgentQualityService {

	@Resource
	private BusinessAgentQualityMapper qualityMapper;
	@Resource
	private BusinessAgentQualitySonMapper qualitySonMapper;

    @Resource
    private BusinessAgentMapper BusinessAgentMapper;

    @Override
	public List<BusinessAgentQuality> queryByQualitycheck(BusinessAgentQuality example) {
		//对list进行处理获取仓房名称和货位名称
		return qualityMapper.queryByExample(example);
	}

	// 保存数据
	@Override
	public Integer save(BusinessAgentQuality qualitycheck) {
        Integer qualityCheckId=0;
        if (qualitycheck.getId() == null) {
            qualityMapper.insertSelective(qualitycheck);// 新增数据
            //如果验收，把页面验收隐藏
//            if("1".equals(qualitycheck.getType())){
//                qualityMapper.updateByFlagType(qualitycheck);
//            }
            qualityCheckId = qualitycheck.getId();
        } else {
            qualityMapper.updateByPrimaryKeySelective(qualitycheck);// 修改数据
            qualityCheckId = qualitycheck.getId();
        }
        return qualityCheckId;
	}

	// 保存字表数据
	@Override
	public void saveOne(BusinessAgentQualitySon qualitycheckone) {
	    if(qualitycheckone.getId() == null){
            qualitySonMapper.insertSelective(qualitycheckone);// 新增数据
        } else {
            qualitySonMapper.updateByPrimaryKeySelective(qualitycheckone);//修改数据
        }
	}

	@Override
	public void remove(int id) {
		// 删除数据
		qualityMapper.deleteByPrimaryKey(id);
	}

	/**
	 * 根据条件获得第三方检查列表
	 * @param qualitycheck
	 * @return
	 */
	@Override
	public List<BusinessAgentQuality> getThirdCheckList(BusinessAgentQuality qualitycheck) {
		return  qualityMapper.getThirdCheckList(qualitycheck);
	}

	@Override
	public List<BusinessAgentQuality> getQualitycheckListByFoodbasicinfoCheck(BusinessAgentQuality qualitycheck) {
		return qualityMapper.getQualitycheckListByFoodbasicinfoCheck(qualitycheck);
	}

	@Override
	public BusinessAgentQuality loadDataById(Integer id) {
		return qualityMapper.queryPrimaryKey(id);
	}

    @Override
    public String getQualityStandardStr(Integer id) {
        String returnStr = "";
        StringBuffer sb = new StringBuffer();
        BusinessAgentQuality qc = qualityMapper.selectByPrimaryKey(id);
        if (qc != null) {
            // 品种.
            Integer subType = qc.getSubType();
            if (subType == 3164) {
                // 小麦.
                if (StringUtils.isNotBlank(qc.getCapacity())) {
                    sb.append("容重").append(qc.getCapacity()).append("g/L;");
                }
                if (StringUtils.isNotBlank(qc.getBadpart())) {
                    sb.append("不完善粒含量").append(qc.getBadpart()).append("%;");
                }

            } else if (subType == 3165) {
                // 玉米.
                if (StringUtils.isNotBlank(qc.getCapacity())) {
                    sb.append("容重").append(qc.getCapacity()).append("g/L;");
                }
                if (StringUtils.isNotBlank(qc.getBadpart())) {
                    sb.append("不完善粒含量总计").append(qc.getBadpart()).append("%;");
                }
                if (StringUtils.isNotBlank(qc.getMildewCount())) {
                    sb.append("其中：生霉粒").append(qc.getMildewCount()).append("%;");
                }
            } else if (subType == 3166) {
                // 稻谷.
                if (StringUtils.isNotBlank(qc.getHuskedRation())) {
                    sb.append("出糙率").append(qc.getMildewCount()).append("%;");
                }
                if (StringUtils.isNotBlank(qc.getFullGoodRation())) {
                    sb.append("整精米率").append(qc.getFullGoodRation()).append("%;");
                }
                if (StringUtils.isNotBlank(qc.getYellowPart())) {
                    sb.append("黄粒米").append(qc.getYellowPart()).append("%;");
                }
                if (StringUtils.isNotBlank(qc.getOutHuskedRation())) {
                    sb.append("谷外糙米").append(qc.getOutHuskedRation()).append("%;");
                }
            } else if (subType == 2777) {
                // 大豆.
                if (StringUtils.isNotBlank(qc.getGoodpart())) {
                    sb.append("完整粒率").append(qc.getGoodpart()).append("%;");
                }
                if (StringUtils.isNotBlank(qc.getDamageRatio())) {
                    sb.append("损伤粒率").append(qc.getDamageRatio()).append("%;");
                }
                if (StringUtils.isNotBlank(qc.getHotDamageRatio())) {
                    sb.append("其中：热损伤粒").append(qc.getHotDamageRatio()).append("%;");
                }
            }

            if (StringUtils.isNotBlank(qc.getImpurity())) {
                sb.append("杂质").append(qc.getImpurity()).append("%;");
            }
            if (StringUtils.isNotBlank(qc.getWater())) {
                sb.append("水分").append(qc.getWater()).append("%;");
            }
            if (StringUtils.isNotBlank(qc.getColorsmell())) {
                sb.append("色泽气味").append(qc.getColorsmell()).append(";");
            }
            returnStr = sb.toString();
        }
        return returnStr;
    }

    @Override
    public List<BusinessAgentQuality> getHouseOrWareList(
            BusinessAgentQuality qualitycheck) {
        List<BusinessAgentQuality> list = null;
        //5：第三方检查
        qualitycheck.setType("5");

        // 仓房id.
        if (qualitycheck.getStorehouseId() != null) {
            list = qualityMapper.getWareHouseIdList(qualitycheck);
        } else {
            list = qualityMapper.getHouseIdList(qualitycheck);
        }
        return list;
    }

    /**
     * 更新质量管理为历史数据
     * @param houseId
     * @return
     */
    @Override
    public void setQualityCheckByHistoryStatus(Integer houseId,Integer warehouseId) {

        BusinessAgentQuality qualitycheck = new BusinessAgentQuality();
        //0:最新数据  1:历史数据
        qualitycheck.setHistoryStatus(1);

        BusinessAgentQualityExample qualityCheckExample = new BusinessAgentQualityExample();
        BusinessAgentQualityExample.Criteria qualityCriteria = qualityCheckExample.createCriteria();
        if(houseId != null){
            qualityCriteria.andStorehouseIdEqualTo(houseId);
        }
        if(warehouseId != null){
            qualityCriteria.andWarehouseIdEqualTo(warehouseId);
        }

        //更新质量管理状态为历史数据
        qualityMapper.updateByExampleSelective(qualitycheck,qualityCheckExample);

    }

    @Override
    public List<Map<String,Object>> getStoreQualityList() {
        return qualityMapper.getStoreQualityList();
    }
    

	@Override
	public List<BusinessAgentQuality> getTrdStoreQualityList() {
		// TODO Auto-generated method stub
		return qualityMapper.getTrdStoreQualityList();
	}


    /**
     * 新增验收数据
     * @throws Exception
     */
    @Override
    @Transactional(readOnly = false)
    public List<BusinessAgentQuality> getDataByZJId(Map<String, Object> paramMap) {
        return qualityMapper.getDataByZJId(paramMap);
    }

    @Override
    public List<BusinessAgentQuality> queryByQualitycheckData(BusinessAgentQuality example) {

        return qualityMapper.queryByExampleData(example);
    }

    @Override
    public List<BusinessAgentQuality> queryByQualitycheckusiness(BusinessAgentQuality qualityCheckExample) {

        return qualityMapper.queryByQualitycheckusiness(qualityCheckExample);
    }

	@Override
	public List<BusinessAgentQuality> findByCondition(BusinessAgentQualityExample example) {
		return qualityMapper.selectByExample(example);
	}

    @Override
    public String importData(List<List<String>> list, Integer orgId, Map<String, Object> agentMap, String checktype) {
        Date date = new Date();
        BusinessAgentQuality agent = null;
        Map<String,Object> enumData = new HashMap<>();
        Map<String,Object> enumId = new HashMap<>();

        String msg = "";
        int len = 0;

        for (int i = 0; i < list.size(); i++) {
            List<String> revList = list.get(i);

            for (int j = 0; j < revList.size(); j++) {
                switch(j) {
                    case 0:
                        //仓房名称
                        agent = new BusinessAgentQuality();
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 1 列的值的长度不能超过20！";
                            return msg;
                        }
                        enumData.put("storehouseName", revList.get(j));
                        enumData.put("depotId", agentMap.get("depotId"));
                        Map<String,Object> storehouseId = BusinessAgentMapper.getStorehouseId(enumData);
                        if(ParameterUtil.isnull(storehouseId)){
                            msg = "第 "+(i+3)+" 行第 1 列的值的不正确，请查询后再添加！";
                            return msg;
                        }
                        agent.setOrgId(orgId);
                        agent.setStorehouseId(Integer.parseInt(storehouseId.get("storehouseId").toString()));
                        break;
                    case 1:
                        //货位名称
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 2 列的值的长度不能超过20！";
                            return msg;
                        }
                        enumData.put("warehouseName", revList.get(j));
                        Map<String,Object> warehouseId = BusinessAgentMapper.getWarehouseId(enumData);
                        if(ParameterUtil.isnull(warehouseId)){
                            msg = "第 "+(i+3)+" 行第 2 列的值的不正确，请查询后再添加！";
                            return msg;
                        }
                        agent.setWarehouseId(Integer.parseInt(warehouseId.get("warehouseId").toString()));
                        break;
                    case 2:
                        enumId = null;
                        //粮油品种
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 3 列的值的长度不能超过20！";
                            return msg;
                        }
                        enumData.put("enumName", revList.get(j));
                        enumData.put("parentId", "1061");
                        enumId = BusinessAgentMapper.getEnumId(enumData);
                        if(enumId.size() == 0){
                            msg = "第 "+(i+3)+" 行第 3 列的值的不正确，请查询后再添加！";
                            return msg;
                        }
                        agent.setSubType(Integer.parseInt(enumId.get("enumId").toString()));

                        //检验标准依据
                        //用于判断品种的检验标准依据的值  该值从词典枚举中取出的()
                        if (ParameterUtil.isequal(Integer.parseInt(enumId.get("enumId").toString()),3164)) {
                            // 小麦
                            agent.setInspectionStandardBasis("5523"); ;
                        } else if(ParameterUtil.isequal(Integer.parseInt(enumId.get("enumId").toString()),3165)) {
                            // 玉米
                            agent.setInspectionStandardBasis("5524"); ;
                        }else if(ParameterUtil.isequal(Integer.parseInt(enumId.get("enumId").toString()),3166)) {
                            // 稻谷
                            agent.setInspectionStandardBasis("5526"); ;
                        }else if(ParameterUtil.isequal(Integer.parseInt(enumId.get("enumId").toString()),2777)) {
                            // 大豆
                            agent.setInspectionStandardBasis("5525"); ;
                        }else if(ParameterUtil.isequal(Integer.parseInt(enumId.get("enumId").toString()),6905)) {
                            // 粮油
                            agent.setInspectionStandardBasis("6908"); ;
                        }
                        break;
                    case 3:
                        //明细品种
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 4 列的值的长度不能超过20！";
                            return msg;
                        }
                        enumData.put("enumName", revList.get(j));
                        enumData.put("parentId", enumId.get("enumId").toString());
                        Map<String,Object> lsmxId = BusinessAgentMapper.getEnumId(enumData);
                        if(enumId.size() == 0){
                            msg = "第 "+(i+3)+" 行第 4 列的值的不正确，请查询后再添加！";
                            return msg;
                        }
                        agent.setSubTypeDetailed(Integer.parseInt(lsmxId.get("enumId").toString()));
                        break;
                    case 4:
                        //粮油性质
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 5 列的值的长度不能超过20！";
                            return msg;
                        }
                        if(ParameterUtil.isequal(revList.get(j),"其他粮")){
                            agent.setQuality("3103");
                        }else{
                            enumData.put("enumName", revList.get(j));
                            enumData.put("parentId", "1032");
                            Map<String,Object> natureId = BusinessAgentMapper.getEnumChildId(enumData);

                            if(natureId.size() == 0){
                                msg = "第 "+(i+3)+" 行第 5 列的值的不正确，请查询后再添加！";
                                return msg;
                            }
                            agent.setQuality(natureId.get("enumId").toString());
                        }
                        break;
                    case 5:
                        //数量
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 6 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setNumber(revList.get(j));
                        break;
                    case 6:
                        //入仓日期
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 7 列的值的长度不能超过20！";
                            return msg;
                        }
                        agent.setInputTime(ParameterUtil.string2date(revList.get(j)));
                        break;
                    case 7:
                        //收获年度
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 8 列的值的长度不能超过20！";
                            return msg;
                        }
                        enumData.put("enumName", revList.get(j));
                        enumData.put("parentId", "1004");
                        Map<String,Object> yearId = BusinessAgentMapper.getEnumId(enumData);
                        if(yearId.size() == 0){
                            msg = "第 "+(i+3)+" 行第 8 列的值的不正确，请查询后再添加！";
                            return msg;
                        }
                        agent.setHarvestTime(Integer.parseInt(yearId.get("enumId").toString()));
                        break;
                    case 8:
                        //产地
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 9 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setLocation(revList.get(j));
                        break;
                    case 9:
                        //保管员
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 10 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setKeeper(revList.get(j));
                        break;
                    case 10:
                        //扦样日期
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 11 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setChooseTime(ParameterUtil.string2date(revList.get(j)));
                        break;
                    case 11:
                        //扦样人
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 12 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setChooser(revList.get(j));
                        break;
                    case 12:
                        //检验日期
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 13 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setCheckTime(ParameterUtil.string2date(revList.get(j)));
                        break;
                    case 13:
                        //报告出具日期
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 14 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setCheckResultTime(ParameterUtil.string2date(revList.get(j)));
                        break;
                    case 14:
                        //检验结论
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 15 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        if(ParameterUtil.isequal(revList.get(j),"合格")){
                            agent.setCheckResult("0");
                        }else if(ParameterUtil.isequal(revList.get(j),"不合格")){
                            agent.setCheckResult("1");
                        }else{
                            msg = "第 "+(i+3)+" 行第 15 列的值不是规定值，请查询后再导入！";
                            return msg;
                        }
                        break;
                    case 15:
                        //检验机构
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 16 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setAcceptUnite(revList.get(j));
                        break;
                    case 16:
                        //储存品质
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 17 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        if(ParameterUtil.isequal(revList.get(j),"宜存")){
                            agent.setStoreQuality("0");
                        }else if(ParameterUtil.isequal(revList.get(j),"不宜存")){
                            agent.setStoreQuality("1");
                        }else{
                            msg = "第 "+(i+3)+" 行第 17 列的值不是规定值，请查询后再导入！";
                            return msg;
                        }
                        break;
                    case 17:
                        //水分%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 18 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setWater(revList.get(j));
                        break;
                    case 18:
                        //容量（g/L）
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 19 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setCapacity(revList.get(j));
                        break;
                    case 19:
                        //杂质%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 20 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setImpurity(revList.get(j));
                        break;
                    case 20:
                        //矿物质%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 21 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setMineral(revList.get(j));
                        break;
                    case 21:
                        //不完善颗粒%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 22 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setBadpart(revList.get(j));
                        break;
                    case 22:
                        //生霉粒%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 23 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setMildewCount(revList.get(j));
                        break;
                    case 23:
                        //完整粒率%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 24 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setGoodpart(revList.get(j));
                        break;
                    case 24:
                        //损伤粒率%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 25 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setDamageRatio(revList.get(j));
                        break;
                    case 25:
                        //热损伤粒%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 26 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setHotDamageRatio(revList.get(j));
                        break;
                    case 26:
                        //出糙率%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 27 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setHuskedRation(revList.get(j));
                        break;
                    case 27:
                        //整精米率%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 28 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setFullGoodRation(revList.get(j));
                        break;
                    case 28:
                        //黄粒米%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 29 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setYellowPart(revList.get(j));
                        break;
                    case 29:
                        //谷外糙米%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 30 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setOutHuskedRation(revList.get(j));
                        break;
                    case 30:
                        //互混率%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 31 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setIntermixingRate(revList.get(j));
                        break;
                    case 31:
                        //色泽气味
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 32 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setColorsmell(revList.get(j));
                        break;
                    case 32:
                        //等级
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 33 列的值的长度不能超过20！";
                            return msg;
                        }
                        enumData.put("enumName", revList.get(j));
                        enumData.put("parentId", "1002");
                        Map<String,Object> levelId = BusinessAgentMapper.getEnumId(enumData);
                        if(levelId.size() == 0){
                            msg = "第 "+(i+3)+" 行第 33 列的值的不正确，请查询后再添加！";
                            return msg;
                        }
                        agent.setLevel(Integer.parseInt(levelId.get("enumId").toString()));
                        break;
                    case 33:
                        //是否虫粮
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 34 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        if(ParameterUtil.isequal(revList.get(j),"是")){
                            agent.setIsPest("0");
                        }else if(ParameterUtil.isequal(revList.get(j),"否")){
                            agent.setIsPest("1");
                        }else{
                            msg = "第 "+(i+3)+" 行第 34 列的值不是规定值，请查询后再导入！";
                            return msg;
                        }
                        break;
                    case 34:
                        //备注
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 35 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setRemarks(revList.get(j));
                        break;
                    default :
                        break;
                }
            }
            agent.setType(checktype);
            agent.setHistoryStatus(0);
            agent.setSealStatus("0");
            agent.setAgentId(Integer.parseInt(agentMap.get("agentId").toString()));
            agent.setAgentDepotId(Integer.parseInt(agentMap.get("depotId").toString()));
            qualityMapper.insert(agent);
        }
        return msg;
    }

    @Override
    public String importDataCQ(List<List<String>> list, Integer orgId, Map<String, Object> agentMap, String checktype) {
        Date date = new Date();
        BusinessAgentQuality agent = null;
        Map<String,Object> enumData = new HashMap<>();
        Map<String,Object> enumId = new HashMap<>();

        String msg = "";
        int len = 0;

        for (int i = 0; i < list.size(); i++) {
            List<String> revList = list.get(i);

            for (int j = 0; j < revList.size(); j++) {
                switch(j) {
                    case 0:
                        //仓房名称
                        agent = new BusinessAgentQuality();
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 1 列的值的长度不能超过20！";
                            return msg;
                        }
                        enumData.put("storehouseName", revList.get(j));
                        enumData.put("depotId", agentMap.get("depotId"));
                        Map<String,Object> storehouseId = BusinessAgentMapper.getStorehouseId(enumData);
                        if(ParameterUtil.isnull(storehouseId)){
                            msg = "第 "+(i+3)+" 行第 1 列的值的不正确，请查询后再添加！";
                            return msg;
                        }
                        agent.setOrgId(orgId);
                        agent.setStorehouseId(Integer.parseInt(storehouseId.get("storehouseId").toString()));
                        break;
                    case 1:
                        //货位名称
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 2 列的值的长度不能超过20！";
                            return msg;
                        }
                        enumData.put("warehouseName", revList.get(j));
                        Map<String,Object> warehouseId = BusinessAgentMapper.getWarehouseId(enumData);
                        if(ParameterUtil.isnull(warehouseId)){
                            msg = "第 "+(i+3)+" 行第 2 列的值的不正确，请查询后再添加！";
                            return msg;
                        }
                        agent.setWarehouseId(Integer.parseInt(warehouseId.get("warehouseId").toString()));
                        break;
                    case 2:
                        enumId = null;
                        //粮油品种
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 3 列的值的长度不能超过20！";
                            return msg;
                        }
                        enumData.put("enumName", revList.get(j));
                        enumData.put("parentId", "1061");
                        enumId = BusinessAgentMapper.getEnumId(enumData);
                        if(enumId.size() == 0){
                            msg = "第 "+(i+3)+" 行第 3 列的值的不正确，请查询后再添加！";
                            return msg;
                        }
                        agent.setSubType(Integer.parseInt(enumId.get("enumId").toString()));

                        //检验标准依据
                        //用于判断品种的检验标准依据的值  该值从词典枚举中取出的()
                        if (ParameterUtil.isequal(Integer.parseInt(enumId.get("enumId").toString()),3164)) {
                            // 小麦
                            agent.setInspectionStandardBasis("5523"); ;
                        } else if(ParameterUtil.isequal(Integer.parseInt(enumId.get("enumId").toString()),3165)) {
                            // 玉米
                            agent.setInspectionStandardBasis("5524"); ;
                        }else if(ParameterUtil.isequal(Integer.parseInt(enumId.get("enumId").toString()),3166)) {
                            // 稻谷
                            agent.setInspectionStandardBasis("5526"); ;
                        }else if(ParameterUtil.isequal(Integer.parseInt(enumId.get("enumId").toString()),2777)) {
                            // 大豆
                            agent.setInspectionStandardBasis("5525"); ;
                        }else if(ParameterUtil.isequal(Integer.parseInt(enumId.get("enumId").toString()),6905)) {
                            // 粮油
                            agent.setInspectionStandardBasis("6908"); ;
                        }
                        break;
                    case 3:
                        //明细品种
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 4 列的值的长度不能超过20！";
                            return msg;
                        }
                        enumData.put("enumName", revList.get(j));
                        enumData.put("parentId", enumId.get("enumId").toString());
                        Map<String,Object> lsmxId = BusinessAgentMapper.getEnumId(enumData);
                        if(enumId.size() == 0){
                            msg = "第 "+(i+3)+" 行第 4 列的值的不正确，请查询后再添加！";
                            return msg;
                        }
                        agent.setSubTypeDetailed(Integer.parseInt(lsmxId.get("enumId").toString()));
                        break;
                    case 4:
                        //粮油性质
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 5 列的值的长度不能超过20！";
                            return msg;
                        }
                        if(ParameterUtil.isequal(revList.get(j),"其他粮")){
                            agent.setQuality("3103");
                        }else{
                            enumData.put("enumName", revList.get(j));
                            enumData.put("parentId", "1032");
                            Map<String,Object> natureId = BusinessAgentMapper.getEnumChildId(enumData);

                            if(natureId.size() == 0){
                                msg = "第 "+(i+3)+" 行第 5 列的值的不正确，请查询后再添加！";
                                return msg;
                            }
                            agent.setQuality(natureId.get("enumId").toString());
                        }
                        break;
                    case 5:
                        //数量
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 6 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setNumber(revList.get(j));
                        break;
                    case 6:
                        //入仓日期
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 7 列的值的长度不能超过20！";
                            return msg;
                        }
                        agent.setInputTime(ParameterUtil.string2date(revList.get(j)));
                        break;
                    case 7:
                        //收获年度
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 8 列的值的长度不能超过20！";
                            return msg;
                        }
                        enumData.put("enumName", revList.get(j));
                        enumData.put("parentId", "1004");
                        Map<String,Object> yearId = BusinessAgentMapper.getEnumId(enumData);
                        if(yearId.size() == 0){
                            msg = "第 "+(i+3)+" 行第 8 列的值的不正确，请查询后再添加！";
                            return msg;
                        }
                        agent.setHarvestTime(Integer.parseInt(yearId.get("enumId").toString()));
                        break;
                    case 8:
                        //产地
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 9 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setLocation(revList.get(j));
                        break;
                    case 9:
                        //保管员
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 10 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setKeeper(revList.get(j));
                        break;
                    case 10:
                        if(ParameterUtil.isequal(checktype,"2")){//春秋普查
                            //春秋普查类型
                            if (ParameterUtil.isnotnull(revList.get(j))) {
                                len = revList.get(j).length();
                                if (len > 50) {
                                    msg = "第 "+(i+3)+" 行第 11 列的值的长度不能超过50！";
                                    return msg;
                                }
                            }
                            if(ParameterUtil.isequal(revList.get(j),"春")){
                                agent.setCheckTimeType("0");
                            }else if(ParameterUtil.isequal(revList.get(j),"秋")){
                                agent.setCheckTimeType("1");
                            }else{
                                msg = "第 "+(i+3)+" 行第 11 列的值不是规定值，请查询后再导入！";
                                return msg;
                            }
                        }else if(ParameterUtil.isequal(checktype,"1")){//验收
                            //申请验收日期
                            if (ParameterUtil.isnotnull(revList.get(j))) {
                                len = revList.get(j).length();
                                if (len > 50) {
                                    msg = "第 "+(i+3)+" 行第 11 列的值的长度不能超过50！";
                                    return msg;
                                }
                            }
                            agent.setApplyCheckTime(ParameterUtil.string2date(revList.get(j)));
                        }

                        break;
                    case 11:
                        //扦样日期
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 12 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setChooseTime(ParameterUtil.string2date(revList.get(j)));
                        break;
                    case 12:
                        //扦样人
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 13 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setChooser(revList.get(j));
                        break;
                    case 13:
                        //检验日期
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 14 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setCheckTime(ParameterUtil.string2date(revList.get(j)));
                        break;
                    case 14:
                        //报告出具日期
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 15 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setCheckResultTime(ParameterUtil.string2date(revList.get(j)));
                        break;
                    case 15:
                        //检验结论
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 16 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        if(ParameterUtil.isequal(revList.get(j),"合格")){
                            agent.setCheckResult("0");
                        }else if(ParameterUtil.isequal(revList.get(j),"不合格")){
                            agent.setCheckResult("1");
                        }else{
                            msg = "第 "+(i+3)+" 行第 16 列的值不是规定值，请查询后再导入！";
                            return msg;
                        }
                        break;
                    case 16:
                        //检验机构
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 17 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setAcceptUnite(revList.get(j));
                        break;
                    case 17:
                        //储存品质
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 18 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        if(ParameterUtil.isequal(revList.get(j),"宜存")){
                            agent.setStoreQuality("0");
                        }else if(ParameterUtil.isequal(revList.get(j),"不宜存")){
                            agent.setStoreQuality("1");
                        }else{
                            msg = "第 "+(i+3)+" 行第 18 列的值不是规定值，请查询后再导入！";
                            return msg;
                        }
                        break;
                    case 18:
                        //水分%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 19 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setWater(revList.get(j));
                        break;
                    case 19:
                        //容量（g/L）
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 20 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setCapacity(revList.get(j));
                        break;
                    case 20:
                        //杂质%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 21 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setImpurity(revList.get(j));
                        break;
                    case 21:
                        //矿物质%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 22 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setMineral(revList.get(j));
                        break;
                    case 22:
                        //不完善颗粒%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 23 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setBadpart(revList.get(j));
                        break;
                    case 23:
                        //生霉粒%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 24 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setMildewCount(revList.get(j));
                        break;
                    case 24:
                        //完整粒率%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 25 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setGoodpart(revList.get(j));
                        break;
                    case 25:
                        //损伤粒率%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 26 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setDamageRatio(revList.get(j));
                        break;
                    case 26:
                        //热损伤粒%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 27 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setHotDamageRatio(revList.get(j));
                        break;
                    case 27:
                        //出糙率%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 28 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setHuskedRation(revList.get(j));
                        break;
                    case 28:
                        //整精米率%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 29 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setFullGoodRation(revList.get(j));
                        break;
                    case 29:
                        //黄粒米%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 30 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setYellowPart(revList.get(j));
                        break;
                    case 30:
                        //谷外糙米%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 31 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setOutHuskedRation(revList.get(j));
                        break;
                    case 31:
                        //互混率%
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 32 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setIntermixingRate(revList.get(j));
                        break;
                    case 32:
                        //色泽气味
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 33 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setColorsmell(revList.get(j));
                        break;
                    case 33:
                        //等级
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+3)+" 行第 34 列的值的长度不能超过20！";
                            return msg;
                        }
                        enumData.put("enumName", revList.get(j));
                        enumData.put("parentId", "1002");
                        Map<String,Object> levelId = BusinessAgentMapper.getEnumId(enumData);
                        if(levelId.size() == 0){
                            msg = "第 "+(i+3)+" 行第 34 列的值的不正确，请查询后再添加！";
                            return msg;
                        }
                        agent.setLevel(Integer.parseInt(levelId.get("enumId").toString()));
                        break;
                    case 34:
                        //是否虫粮
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 35 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        if(ParameterUtil.isequal(revList.get(j),"是")){
                            agent.setIsPest("0");
                        }else if(ParameterUtil.isequal(revList.get(j),"否")){
                            agent.setIsPest("1");
                        }else{
                            msg = "第 "+(i+3)+" 行第 35 列的值不是规定值，请查询后再导入！";
                            return msg;
                        }
                        break;
                    case 35:
                        //备注
                        if (ParameterUtil.isnotnull(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+3)+" 行第 36 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setRemarks(revList.get(j));
                        break;
                    default :
                        break;
                }
            }
            agent.setType(checktype);
            agent.setHistoryStatus(0);
            agent.setSealStatus("0");
            agent.setAgentId(Integer.parseInt(agentMap.get("agentId").toString()));
            agent.setAgentDepotId(Integer.parseInt(agentMap.get("depotId").toString()));
            qualityMapper.insert(agent);
        }
        return msg;
    }
}